const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let n;
let me=0,mme=0,ct1=0,k;
let x = [];
let y = [];
let dx = [];
let dy = [];
let r =[]; 
let m=[];
let rand;
let ang;
let f1 = [];
let f = [];
let i,j,ij,me1,me2,e1,e2,flag1,flag2,flag3,col,pe1,pe2,spe1,sspe1,ee,ee2,bgx,bgy,rrgy,bp1,bbp1,rp1,rrp1,pv,sr,ox,oy;
let red,green,blue;
let Str=0;
let buffer = null;
let d = { width: canvas.width, height: canvas.height };

function init() {
	flag1=1;flag2=1;flag3=0;me=0;bgx=0;bgy=0;rgy=0,bbgy=0;rrgy=0;col=1;
	bbp1=0;bb1=0;rp1=0;gv=0;pv=6;n=100;
	sr=(d.height-60)/2;
	ox=d.width/2;
	oy=d.height/2;

    buffer = createBuffer(d.width, d.height);
    drawToBuffer();
	for(i=0;i<n;i++){
		r[i]=8;
		m[i]=1;
	}
	for(i=0;i<n;i++){
		rand=Math.random()*(sr-r[i]);
		ang=Math.random()*2*Math.PI;
		x[i]=ox+0.8*rand*Math.cos(ang);
		y[i]=oy+0.8*rand*Math.sin(ang);
		dx[i]=Math.random()*pv;
		if (Math.floor(Math.random() * 2)==0)
			dx[i]=-dx[i];
		dy[i]=Math.random()*pv;
		if (Math.floor(Math.random() * 2)==0)
			dy[i]=-dy[i];
		me=0;me2=0;
	}
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");
	
	    if(Str!==1){
		g.fillStyle = "white";
        g.fillRect(0, 0, d.width, d.height);
		}	

   
	g.fillStyle = "blue";
	for ( i= 0; i <n; i++) {
	g.beginPath();
        g.arc(x[i], y[i], r[i], 0, Math.PI * 2);
        g.fill();
	}	
	
	g.beginPath();
	g.arc(ox,oy, sr, 0, Math.PI * 2);
	g.strokeStyle = "black";
	g.lineWidth=1;    
    g.stroke();
		
     
}

function move() {
	
	let bx = [],by=[],bdx=[],bdy=[];rx=[],ry=[],brx=[],bry=[],cx=[],cy=[];
	let b,a,aa,bb,dd,bdd,rr,drr,brr,crr,s1,s2,s,t,p,q,u,v,k;
	me=me+1;mme=mme+1;
	 for (i= 0; i <n; i++) {
		f[i]=0;
		bx[i]=x[i];
		by[i]=y[i];
		dy[i]=dy[i]  
		bdx[i]=dx[i];
		bdy[i]=dy[i];
		
		x[i]=x[i]+dx[i];
		y[i]=y[i]+dy[i];
			
		rx[i]=x[i]-ox;
		ry[i]=y[i]-oy;
		brx[i]=bx[i]-ox;
		bry[i]=by[i]-oy;
		rr=rx[i]*rx[i]+ry[i]*ry[i];
		drr=dx[i]*dx[i]+dy[i]*dy[i];
		brr=brx[i]*brx[i]+bry[i]*bry[i];
			
		s1=Math.sqrt(rr)-sr;
		s2=Math.sqrt(brr)-sr;
		cx[i]=bx[i]+(s1/(s1+s2))*dx[i];
		cy[i]=by[i]+(s1/(s1+s2))*dy[i];
		crr=cx[i]*cx[i]+cy[i]*cy[i];
		
	if (rr>((sr-r[i])*(sr-r[i]))){	
		x[i]=cx[i];
	    y[i]=cy[i];
			
        dx[i]=-(((2*brx[i]*brx[i]/brr)-1)*((2*bdx[i]*bdx[i]/drr)-1)+4*brx[i]*bry[i]*bdx[i]*bdy[i]/(brr*drr))*bdx[i]+((2*brx[i]*bry[i]/brr)*((2*bdx[i]*bdx[i]/drr)-1)-(2*bdx[i]*bdy[i]/drr)*((2*brx[i]*brx[i]/brr)-1))*bdy[i];
	    dy[i]=-(((2*brx[i]*brx[i]/brr)-1)*((2*bdx[i]*bdx[i]/drr)-1)+4*brx[i]*bry[i]*bdx[i]*bdy[i]/(brr*drr))*bdy[i]-((2*brx[i]*bry[i]/brr)*((2*bdx[i]*bdx[i]/drr)-1)-(2*bdx[i]*bdy[i]/drr)*((2*brx[i]*brx[i]/brr)-1))*bdx[i];
		x[i]=bx[i];
        y[i]=by[i];
	           //bdx[i]=dx[i];bdy[i]=dy[i];
		}
		}	
		
	
	/*for ( i = 0; i < n; i++) {
		f1[i] = 1;
	}*/
	
	for ( i = 0; i < n; i++) {
    f1[i] = [];
    for ( j = 0; j < n; j++) {
        f1[i][j] = 1;
    }
}
	
	
	
	
	
	
	for ( i = 0; i < n; i++) {
	for ( j = 0; j< n; j++) {
		a=x[j]-x[i]+r[j]-r[i];
		aa=bx[j]-bx[i]+r[j]-r[i];
		b=y[j]-y[i]+r[j]-r[i];
		bb=by[j]-by[i]+r[j]-r[i];
		dd=a*a+b*b;
		bdd=aa*aa+bb*bb;
	if (dd!=0&&dd<=(r[i]+r[j])*(r[i]+r[j])&&j!=i&&dd<bdd&&f1[i][j]==1){ 
		s=(m[i]-m[j])/(m[i]+m[j]);
		t=(2*m[j])/(m[i]+m[j]);
		p=(a*bdy[i]-b*bdx[i]);
		q=(s*(a*bdx[i]+bdy[i])+t*(a*bdx[j]+b*bdy[j]));
		u=(a*q-b*p)/dd;
		v=(b*q+a*p)/dd;
		
		if (col==1){
		dx[i]=u;
		dy[i]=v;
		for(ij=0;ij<n;ij++){
				f1[i][ij]=0;
				f1[ij][i]=0;
				f1[ij][j]=0;
				f1[j][i]=1;
				}
			j=n;
		
		
		
		}

		
	}
	}
    }
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }   , 20); 
}


document.getElementById('N100').addEventListener('click', N100);
document.getElementById('N3').addEventListener('click', N3);
document.getElementById('N1').addEventListener('click', N1);
document.getElementById('Large').addEventListener('click', Large);
document.getElementById('Small').addEventListener('click', Small);
document.getElementById('Collision').addEventListener('click', Collision);
document.getElementById('nonCollision').addEventListener('click', nonCollision);
document.getElementById('Strobo').addEventListener('click', Strobo);

function N100() {
       
		n=100;Str=0;
		
		
				
}
function N3() {
        
		n=3;Str=0;
		
				
}
function N1() {
        
		n=1;Str=0;

}
function Large() {
        for(i=0;i<n;i++){ 
			r[i]=8;
	        	}					
			
}
function Small() {
        for(i=0;i<n;i++){ 
			r[i]=4;
	        	}	
}
function Collision() {
        col=1;
}
function nonCollision() {
        col=0;          
}
function Strobo() {
        Str=1;          
}

init();
start();